package fr.svpro.rsd;

import android.annotation.SuppressLint;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.SimpleAdapter;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Objects;

import okhttp3.Call;
import okhttp3.Callback;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.Response;


public class MainActivity extends AppCompatActivity {

    private final static String URL = "https://radiobrowser.weblib.re/json/stations/byname/";
    private ListView listView;
    private EditText etRecherche;
    private Button bRecherche, bShare, bSite;
    private TextView resultat;
    public String siteWeb;
    private String nomStation;
    private String streamURL;
    ArrayList<HashMap<String, String>> arrayList;



    @SuppressLint("MissingInflatedId")
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        etRecherche = (EditText) findViewById(R.id.etRecherche);
        listView = (ListView) findViewById(R.id.listView);
        bRecherche = (Button) findViewById(R.id.recherche);
        bShare = (Button) findViewById(R.id.share);
        bSite = (Button) findViewById(R.id.siteWeb);
        //resultat = (TextView) findViewById(R.id.resultText);

        bRecherche.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                setTitle("Recherche en cours....");
                bShare.setVisibility(View.INVISIBLE);
                bSite.setVisibility(View.INVISIBLE);
                parse();
            }
        });
    }
    public void parse(){
        arrayList = new ArrayList<>();

        OkHttpClient client = new OkHttpClient();
        Request request = new Request.Builder()
                .url(URL + etRecherche.getText() + "?hidebroken=true")
                .build();

        client.newCall(request).enqueue(new Callback() {
            @Override
            public void onFailure(@NonNull Call call, @NonNull IOException e) {
                e.printStackTrace();
            }

            @Override
            public void onResponse(@NonNull Call call, @NonNull Response response) throws IOException {
                if (response.isSuccessful()) {
                    String pageWeb = response.body().string();
                    MainActivity.this.runOnUiThread(new Runnable() {
                        @Override
                        public void run() {
                            try {
                                //JSONObject object = new JSONObject(pageWeb);
                                JSONArray array = new JSONArray(pageWeb);
                                for (int i = 0; i < array.length(); i++) {
                                    JSONObject object = array.getJSONObject(i);
                                    String name = object.getString("name");
                                    String homepage = object.getString("homepage");
                                    String url = object.getString("url");
                                    HashMap<String, String> data = new HashMap<>();
                                    data.put("name", name);
                                    data.put("homepage", homepage);
                                    data.put("url", url);
                                    arrayList.add(data);
                                    ListAdapter adapter = new SimpleAdapter(MainActivity.this, arrayList, R.layout.list_items
                                            , new String[]{"name", "homepage", "url"}, new int[]{R.id.name, R.id.homepage, R.id.url});
                                    listView.setAdapter(adapter);
                                }
                            } catch (JSONException e) {
                                e.printStackTrace();
                            }
                            setTitle(listView.getCount() + " Radio(s) trouvée(s)");

                            listView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
                                public void onItemClick(AdapterView<?> parent, View view,
                                                        int position, long id) {

                                    nomStation = arrayList.get(position).get("name");// here you have to pas keyname which is put inyour Hashmap arraylist
                                    siteWeb = arrayList.get(position).get("homepage");
                                    streamURL = arrayList.get(position).get("url");

                                    setTitle(nomStation);
                                    bShare.setVisibility(View.VISIBLE);
                                    if (Objects.requireNonNull(arrayList.get(position).get("homepage")).isEmpty()) {
                                        bSite.setVisibility(View.INVISIBLE);
                                    } else {
                                        bSite.setVisibility(View.VISIBLE);
                                    }
                                }
                            });
                            bShare.setOnClickListener(new View.OnClickListener() {
                                @Override
                                public void onClick(View view) {
                                    Intent intent = new Intent(Intent.ACTION_SEND);
                                    intent.setType("text/plain");
                                    intent.putExtra(Intent.EXTRA_TEXT, streamURL);
                                    startActivity(Intent.createChooser(intent,""));

                                }
                            });
                            bSite.setOnClickListener(new View.OnClickListener() {
                                @Override
                                public void onClick(View view) {
                                    Intent intent = new Intent(Intent.ACTION_VIEW);
                                    intent.setData(Uri.parse(siteWeb));
                                    startActivity(intent);
                                }
                            });
                        }
                    });
                }
            }
        });

    }

   /* public ListView getListView() {
        return listView;
    }

    public EditText getEtRecherche() {
        return etRecherche;
    }

    public Button getButton() {
        return bRecherche;
    }

    public TextView getResultat() {
        return resultat;
    }

    public String getPageWeb() {
        return pageWeb;
    }

    public ArrayList<HashMap<String, String>> getArrayList() {
        return arrayList;
    }*/
}